/*
 * Copyright 2006-2007 Queplix Corp.
 *
 * Licensed under the Queplix Public License, Version 1.1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.queplix.com/solutions/commercial-open-source/queplix-public-license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 *
 */

package com.queplix.core.modules.eql;

/**
 * <p>EQL Sub Where Condition abstract class</p>
 *
 * @author Baranov Andrey [ALB]
 * @version $Revision: 1.1.1.1 $ $Date: 2005/09/12 15:30:21 $
 */

public abstract class EQLReqSubWhereCond
        implements java.io.Serializable {

    private EQLReqOp leftMember;
    private EQLReqOp rightMember;

    protected EQLReqSubWhereCond(EQLReqOp leftMember, EQLReqOp rightMember) {
        if(leftMember == null) {
            throw new NullPointerException("Left EQLReqOp cannot be NULL");
        }
        this.leftMember = leftMember;
        this.rightMember = rightMember;
    }

    public EQLReqOp getLeftMember() {
        return leftMember;
    }

    public EQLReqOp getRightMember() {
        return rightMember;
    }

    public int hashCode() {
        return leftMember.hashCode() | rightMember.hashCode();
    }

    public boolean equals(Object o) {
        if(!(o instanceof EQLReqSubWhereCond)) {
            return false;
        }
        if(o == this) {
            return true;
        }

        EQLReqSubWhereCond reqSubWhereCond = (EQLReqSubWhereCond) o;
        return leftMember.equals(reqSubWhereCond.getLeftMember()) &&
                ((rightMember != null && rightMember.equals(
                        reqSubWhereCond.getRightMember())) ||
                        (rightMember == null
                                && reqSubWhereCond.getRightMember() == null));
    }
}
